-- Add foreign keys to ART database tables

-- the unique constraints below may be needed for databases created before 3.3
-- ALTER TABLE ART_USERS ADD CONSTRAINT art_u_uq_u_id UNIQUE(USER_ID);
-- ALTER TABLE ART_RULES ADD CONSTRAINT art_rul_uq_r_id UNIQUE(RULE_ID);
-- ALTER TABLE ART_JOB_SCHEDULES ADD CONSTRAINT art_jbsch_uq_s_id UNIQUE(SCHEDULE_ID);

ALTER TABLE ART_USERS ADD CONSTRAINT art_u_fk_acc_lvl FOREIGN KEY(ACCESS_LEVEL) REFERENCES ART_ACCESS_LEVELS(ACCESS_LEVEL);
ALTER TABLE ART_USERS ADD CONSTRAINT art_u_fk_def_qr_grp FOREIGN KEY(DEFAULT_QUERY_GROUP) REFERENCES ART_QUERY_GROUPS(QUERY_GROUP_ID);
ALTER TABLE ART_USER_GROUPS ADD CONSTRAINT art_ug_fk_dqg FOREIGN KEY(DEFAULT_QUERY_GROUP) REFERENCES ART_QUERY_GROUPS(QUERY_GROUP_ID);
ALTER TABLE ART_USER_USERGROUP_MAP ADD CONSTRAINT art_uugm_fk_ug_id FOREIGN KEY(USER_GROUP_ID) REFERENCES ART_USER_GROUPS(USER_GROUP_ID);
ALTER TABLE ART_USER_USERGROUP_MAP ADD CONSTRAINT art_uugm_fk_u_id FOREIGN KEY(USER_ID) REFERENCES ART_USERS(USER_ID);
ALTER TABLE ART_QUERIES ADD CONSTRAINT art_q_fk_qt FOREIGN KEY(QUERY_TYPE) REFERENCES ART_REPORT_TYPES(REPORT_TYPE);
ALTER TABLE ART_QUERIES ADD CONSTRAINT art_q_fk_ds_id FOREIGN KEY(DATASOURCE_ID) REFERENCES ART_DATABASES(DATABASE_ID);
ALTER TABLE ART_QUERIES ADD CONSTRAINT art_q_fk_enc_id FOREIGN KEY(ENCRYPTOR_ID) REFERENCES ART_ENCRYPTORS(ENCRYPTOR_ID);
ALTER TABLE ART_REPORT_REPORT_GROUPS ADD CONSTRAINT art_rrg_fk_r_id FOREIGN KEY(REPORT_ID) REFERENCES ART_QUERIES(QUERY_ID);
ALTER TABLE ART_REPORT_REPORT_GROUPS ADD CONSTRAINT art_rrg_fk_rg_id FOREIGN KEY(REPORT_GROUP_ID) REFERENCES ART_QUERY_GROUPS(QUERY_GROUP_ID);
ALTER TABLE ART_ADMIN_PRIVILEGES ADD CONSTRAINT art_admpv_fk_u_id FOREIGN KEY(USER_ID) REFERENCES ART_USERS(USER_ID);
ALTER TABLE ART_USER_REPORT_MAP ADD CONSTRAINT art_urm_fk_u_id FOREIGN KEY(USER_ID) REFERENCES ART_USERS(USER_ID);
ALTER TABLE ART_USER_REPORT_MAP ADD CONSTRAINT art_urm_fk_r_id FOREIGN KEY(REPORT_ID) REFERENCES ART_QUERIES(QUERY_ID);
ALTER TABLE ART_USER_REPORTGROUP_MAP ADD CONSTRAINT art_urgm_fk_u_id FOREIGN KEY(USER_ID) REFERENCES ART_USERS(USER_ID);
ALTER TABLE ART_USER_REPORTGROUP_MAP ADD CONSTRAINT art_urgm_fk_rg_id FOREIGN KEY(REPORT_GROUP_ID) REFERENCES ART_QUERY_GROUPS(QUERY_GROUP_ID);
ALTER TABLE ART_PARAMETERS ADD CONSTRAINT art_pmt_fk_dv_r_id FOREIGN KEY(DEFAULT_VALUE_REPORT_ID) REFERENCES ART_QUERIES(QUERY_ID);
ALTER TABLE ART_PARAMETERS ADD CONSTRAINT art_pmt_fk_lov_r_id FOREIGN KEY(LOV_REPORT_ID) REFERENCES ART_QUERIES(QUERY_ID);
ALTER TABLE ART_REPORT_PARAMETERS ADD CONSTRAINT art_rpmt_fk_r_id FOREIGN KEY(REPORT_ID) REFERENCES ART_QUERIES(QUERY_ID);
ALTER TABLE ART_REPORT_PARAMETERS ADD CONSTRAINT art_rpmt_fk_p_id FOREIGN KEY(PARAMETER_ID) REFERENCES ART_PARAMETERS(PARAMETER_ID);
ALTER TABLE ART_QUERY_RULES ADD CONSTRAINT art_qrul_fk_q_id FOREIGN KEY(QUERY_ID) REFERENCES ART_QUERIES(QUERY_ID);
ALTER TABLE ART_QUERY_RULES ADD CONSTRAINT art_qrul_fk_r_id FOREIGN KEY(RULE_ID) REFERENCES ART_RULES(RULE_ID);
ALTER TABLE ART_USER_RULES ADD CONSTRAINT art_urul_fk_u_id FOREIGN KEY(USER_ID) REFERENCES ART_USERS(USER_ID);
ALTER TABLE ART_USER_RULES ADD CONSTRAINT art_urul_fk_r_id FOREIGN KEY(RULE_ID) REFERENCES ART_RULES(RULE_ID);
ALTER TABLE ART_USER_GROUP_RULES ADD CONSTRAINT art_ugrul_fk_ug_id FOREIGN KEY(USER_GROUP_ID) REFERENCES ART_USER_GROUPS(USER_GROUP_ID);
ALTER TABLE ART_USER_GROUP_RULES ADD CONSTRAINT art_ugrul_fk_r_id FOREIGN KEY(RULE_ID) REFERENCES ART_RULES(RULE_ID);
ALTER TABLE ART_JOBS ADD CONSTRAINT art_jb_fk_q_id FOREIGN KEY(QUERY_ID) REFERENCES ART_QUERIES(QUERY_ID);
ALTER TABLE ART_JOBS ADD CONSTRAINT art_jb_fk_u_id FOREIGN KEY(USER_ID) REFERENCES ART_USERS(USER_ID);
ALTER TABLE ART_JOBS ADD CONSTRAINT art_jb_fk_r_q_id FOREIGN KEY(RECIPIENTS_QUERY_ID) REFERENCES ART_QUERIES(QUERY_ID);
ALTER TABLE ART_JOBS ADD CONSTRAINT art_jb_fk_s_id FOREIGN KEY(SCHEDULE_ID) REFERENCES ART_JOB_SCHEDULES(SCHEDULE_ID);
ALTER TABLE ART_JOBS ADD CONSTRAINT art_jb_fk_ss_id FOREIGN KEY(SMTP_SERVER_ID) REFERENCES ART_SMTP_SERVERS(SMTP_SERVER_ID);
ALTER TABLE ART_JOBS ADD CONSTRAINT art_jb_fk_cd_id FOREIGN KEY(CACHED_DATASOURCE_ID) REFERENCES ART_DATABASES(DATABASE_ID);
ALTER TABLE ART_JOBS ADD CONSTRAINT art_jb_fk_sc_id FOREIGN KEY(START_CONDITION_ID) REFERENCES ART_START_CONDITIONS(START_CONDITION_ID);
ALTER TABLE ART_JOBS_PARAMETERS ADD CONSTRAINT art_jbpmt_fk_j_id FOREIGN KEY(JOB_ID) REFERENCES ART_JOBS(JOB_ID);
ALTER TABLE ART_USER_JOB_MAP ADD CONSTRAINT art_ujbm_fk_j_id FOREIGN KEY(JOB_ID) REFERENCES ART_JOBS(JOB_ID);
ALTER TABLE ART_USER_JOB_MAP ADD CONSTRAINT art_ujbm_fk_u_id FOREIGN KEY(USER_ID) REFERENCES ART_USERS(USER_ID);
ALTER TABLE ART_USER_JOB_MAP ADD CONSTRAINT art_ujbm_fk_ug_id FOREIGN KEY(USER_GROUP_ID) REFERENCES ART_USER_GROUPS(USER_GROUP_ID);
ALTER TABLE ART_USER_GROUP_QUERIES ADD CONSTRAINT art_ugq_fk_ug_id FOREIGN KEY(USER_GROUP_ID) REFERENCES ART_USER_GROUPS(USER_GROUP_ID);
ALTER TABLE ART_USER_GROUP_QUERIES ADD CONSTRAINT art_ugq_fk_q_id FOREIGN KEY(QUERY_ID) REFERENCES ART_QUERIES(QUERY_ID);
ALTER TABLE ART_USER_GROUP_GROUPS ADD CONSTRAINT art_uggr_fk_ug_id FOREIGN KEY(USER_GROUP_ID) REFERENCES ART_USER_GROUPS(USER_GROUP_ID);
ALTER TABLE ART_USER_GROUP_GROUPS ADD CONSTRAINT art_uggr_fk_qg_id FOREIGN KEY(QUERY_GROUP_ID) REFERENCES ART_QUERY_GROUPS(QUERY_GROUP_ID);
ALTER TABLE ART_USER_GROUP_JOBS ADD CONSTRAINT art_ugjb_fk_ug_id FOREIGN KEY(USER_GROUP_ID) REFERENCES ART_USER_GROUPS(USER_GROUP_ID);
ALTER TABLE ART_USER_GROUP_JOBS ADD CONSTRAINT art_ugjb_fk_j_id FOREIGN KEY(JOB_ID) REFERENCES ART_JOBS(JOB_ID);
ALTER TABLE ART_DRILLDOWN_QUERIES ADD CONSTRAINT art_drq_fk_q_id FOREIGN KEY(QUERY_ID) REFERENCES ART_QUERIES(QUERY_ID);
ALTER TABLE ART_DRILLDOWN_QUERIES ADD CONSTRAINT art_drq_fk_dq_id FOREIGN KEY(DRILLDOWN_QUERY_ID) REFERENCES ART_QUERIES(QUERY_ID);
ALTER TABLE ART_JOB_ARCHIVES ADD CONSTRAINT art_jbar_fk_j_id FOREIGN KEY(JOB_ID) REFERENCES ART_JOBS(JOB_ID);
ALTER TABLE ART_JOB_ARCHIVES ADD CONSTRAINT art_jbar_fk_u_id FOREIGN KEY(USER_ID) REFERENCES ART_USERS(USER_ID);
ALTER TABLE ART_LOGGED_IN_USERS ADD CONSTRAINT art_lgu_fk_u_id FOREIGN KEY(USER_ID) REFERENCES ART_USERS(USER_ID);
ALTER TABLE ART_SCHEDULE_HOLIDAY_MAP ADD CONSTRAINT art_schhldm_fk_s_id FOREIGN KEY(SCHEDULE_ID) REFERENCES ART_JOB_SCHEDULES(SCHEDULE_ID);
ALTER TABLE ART_SCHEDULE_HOLIDAY_MAP ADD CONSTRAINT art_schhldm_fk_h_id FOREIGN KEY(HOLIDAY_ID) REFERENCES ART_HOLIDAYS(HOLIDAY_ID);
ALTER TABLE ART_JOB_HOLIDAY_MAP ADD CONSTRAINT art_jbhldm_fk_j_id FOREIGN KEY(JOB_ID) REFERENCES ART_JOBS(JOB_ID);
ALTER TABLE ART_JOB_HOLIDAY_MAP ADD CONSTRAINT art_jbhldm_fk_h_id FOREIGN KEY(HOLIDAY_ID) REFERENCES ART_HOLIDAYS(HOLIDAY_ID);
ALTER TABLE ART_JOB_DESTINATION_MAP ADD CONSTRAINT art_jbdstm_fk_j_id FOREIGN KEY(JOB_ID) REFERENCES ART_JOBS(JOB_ID);
ALTER TABLE ART_JOB_DESTINATION_MAP ADD CONSTRAINT art_jbdstm_fk_d_id FOREIGN KEY(DESTINATION_ID) REFERENCES ART_DESTINATIONS(DESTINATION_ID);
ALTER TABLE ART_SAVED_PARAMETERS ADD CONSTRAINT art_svpmt_fk_u_id FOREIGN KEY(USER_ID) REFERENCES ART_USERS(USER_ID);
ALTER TABLE ART_SAVED_PARAMETERS ADD CONSTRAINT art_svpmt_fk_r_id FOREIGN KEY(REPORT_ID) REFERENCES ART_QUERIES(QUERY_ID);
ALTER TABLE ART_USER_PARAM_DEFAULTS ADD CONSTRAINT art_upardf_fk_u_id FOREIGN KEY(USER_ID) REFERENCES ART_USERS(USER_ID);
ALTER TABLE ART_USER_PARAM_DEFAULTS ADD CONSTRAINT art_upardf_fk_p_id FOREIGN KEY(PARAMETER_ID) REFERENCES ART_PARAMETERS(PARAMETER_ID);
ALTER TABLE ART_USER_GROUP_PARAM_DEFAULTS ADD CONSTRAINT art_ugpardf_fk_ug_id FOREIGN KEY(USER_GROUP_ID) REFERENCES ART_USER_GROUPS(USER_GROUP_ID);
ALTER TABLE ART_USER_GROUP_PARAM_DEFAULTS ADD CONSTRAINT art_ugpardf_fk_p_id FOREIGN KEY(PARAMETER_ID) REFERENCES ART_PARAMETERS(PARAMETER_ID);
ALTER TABLE ART_USER_FIXED_PARAM_VAL ADD CONSTRAINT art_ufxparvl_fk_u_id FOREIGN KEY(USER_ID) REFERENCES ART_USERS(USER_ID);
ALTER TABLE ART_USER_FIXED_PARAM_VAL ADD CONSTRAINT art_ufxparvl_fk_p_id FOREIGN KEY(PARAMETER_ID) REFERENCES ART_PARAMETERS(PARAMETER_ID);
ALTER TABLE ART_USER_GROUP_FIXED_PARAM_VAL ADD CONSTRAINT art_ugfxparvl_fk_ug_id FOREIGN KEY(USER_GROUP_ID) REFERENCES ART_USER_GROUPS(USER_GROUP_ID);
ALTER TABLE ART_USER_GROUP_FIXED_PARAM_VAL ADD CONSTRAINT art_ugfxparvl_fk_p_id FOREIGN KEY(PARAMETER_ID) REFERENCES ART_PARAMETERS(PARAMETER_ID);
ALTER TABLE ART_ROLE_PERMISSION_MAP ADD CONSTRAINT art_rolpermm_fk_r_id FOREIGN KEY(ROLE_ID) REFERENCES ART_ROLES(ROLE_ID);
ALTER TABLE ART_ROLE_PERMISSION_MAP ADD CONSTRAINT art_rolpermm_fk_p_id FOREIGN KEY(PERMISSION_ID) REFERENCES ART_PERMISSIONS(PERMISSION_ID);
ALTER TABLE ART_USER_ROLE_MAP ADD CONSTRAINT art_urolm_fk_u_id FOREIGN KEY(USER_ID) REFERENCES ART_USERS(USER_ID);
ALTER TABLE ART_USER_ROLE_MAP ADD CONSTRAINT art_urolm_fk_r_id FOREIGN KEY(ROLE_ID) REFERENCES ART_ROLES(ROLE_ID);
ALTER TABLE ART_USER_GROUP_ROLE_MAP ADD CONSTRAINT art_ugrolm_fk_ug_id FOREIGN KEY(USER_GROUP_ID) REFERENCES ART_USER_GROUPS(USER_GROUP_ID);
ALTER TABLE ART_USER_GROUP_ROLE_MAP ADD CONSTRAINT art_ugrolm_fk_r_id FOREIGN KEY(ROLE_ID) REFERENCES ART_ROLES(ROLE_ID);
ALTER TABLE ART_USER_PERMISSION_MAP ADD CONSTRAINT art_upermm_fk_u_id FOREIGN KEY(USER_ID) REFERENCES ART_USERS(USER_ID);
ALTER TABLE ART_USER_PERMISSION_MAP ADD CONSTRAINT art_upermm_fk_p_id FOREIGN KEY(PERMISSION_ID) REFERENCES ART_PERMISSIONS(PERMISSION_ID);
ALTER TABLE ART_USER_GROUP_PERM_MAP ADD CONSTRAINT art_ugpermm_fk_ug_id FOREIGN KEY(USER_GROUP_ID) REFERENCES ART_USER_GROUPS(USER_GROUP_ID);
ALTER TABLE ART_USER_GROUP_PERM_MAP ADD CONSTRAINT art_ugpermm_fk_p_id FOREIGN KEY(PERMISSION_ID) REFERENCES ART_PERMISSIONS(PERMISSION_ID);
ALTER TABLE ART_PIPELINES ADD CONSTRAINT art_ppln_fk_s_id FOREIGN KEY(SCHEDULE_ID) REFERENCES ART_JOB_SCHEDULES(SCHEDULE_ID);
ALTER TABLE ART_PIPELINES ADD CONSTRAINT art_ppln_fk_sc_id FOREIGN KEY(START_CONDITION_ID) REFERENCES ART_START_CONDITIONS(START_CONDITION_ID);
