-- Upgrade script from ART 2.2 to ART 2.2.1
--
-- Purpose: create/update the tables needed to 
--          . update database version
--          . add support for CUBRID database
-- ------------------------------------------------


-- update database version setting
UPDATE ART_SETTINGS SET SETTING_VALUE='2.2.1' WHERE SETTING_NAME='database version';

-- rename columns that use cubrid reserved words
-- ART_JOBS
ALTER TABLE ART_JOBS ADD OUTPUT_FORMAT VARCHAR(15);
UPDATE ART_JOBS SET OUTPUT_FORMAT=OUTPUT;
ALTER TABLE ART_JOBS DROP COLUMN OUTPUT;

ALTER TABLE ART_JOBS ADD JOB_MINUTE VARCHAR(100);
UPDATE ART_JOBS SET JOB_MINUTE=MINUTE;
ALTER TABLE ART_JOBS DROP COLUMN MINUTE;

ALTER TABLE ART_JOBS ADD JOB_HOUR VARCHAR(100);
UPDATE ART_JOBS SET JOB_HOUR=HOUR;
ALTER TABLE ART_JOBS DROP COLUMN HOUR;

ALTER TABLE ART_JOBS ADD JOB_DAY VARCHAR(100);
UPDATE ART_JOBS SET JOB_DAY=DAY;
ALTER TABLE ART_JOBS DROP COLUMN DAY;

ALTER TABLE ART_JOBS ADD JOB_MONTH VARCHAR(100);
UPDATE ART_JOBS SET JOB_MONTH=MONTH;
ALTER TABLE ART_JOBS DROP COLUMN MONTH;

-- weekday not a cubrid reserved word. just rename for uniformity
ALTER TABLE ART_JOBS ADD JOB_WEEKDAY VARCHAR(100);
UPDATE ART_JOBS SET JOB_WEEKDAY=WEEKDAY;
ALTER TABLE ART_JOBS DROP COLUMN WEEKDAY;

-- ART_JOBS_AUDIT
ALTER TABLE ART_JOBS_AUDIT ADD JOB_ACTION VARCHAR(1);
UPDATE ART_JOBS_AUDIT SET JOB_ACTION=ACTION;
ALTER TABLE ART_JOBS_AUDIT DROP COLUMN ACTION;

-- ART_JOB_SCHEDULES
ALTER TABLE ART_JOB_SCHEDULES ADD JOB_MINUTE VARCHAR(100);
UPDATE ART_JOB_SCHEDULES SET JOB_MINUTE=MINUTE;
ALTER TABLE ART_JOB_SCHEDULES DROP COLUMN MINUTE;

ALTER TABLE ART_JOB_SCHEDULES ADD JOB_HOUR VARCHAR(100);
UPDATE ART_JOB_SCHEDULES SET JOB_HOUR=HOUR;
ALTER TABLE ART_JOB_SCHEDULES DROP COLUMN HOUR;

ALTER TABLE ART_JOB_SCHEDULES ADD JOB_DAY VARCHAR(100);
UPDATE ART_JOB_SCHEDULES SET JOB_DAY=DAY;
ALTER TABLE ART_JOB_SCHEDULES DROP COLUMN DAY;

ALTER TABLE ART_JOB_SCHEDULES ADD JOB_MONTH VARCHAR(100);
UPDATE ART_JOB_SCHEDULES SET JOB_MONTH=MONTH;
ALTER TABLE ART_JOB_SCHEDULES DROP COLUMN MONTH;

ALTER TABLE ART_JOB_SCHEDULES ADD JOB_WEEKDAY VARCHAR(100);
UPDATE ART_JOB_SCHEDULES SET JOB_WEEKDAY=WEEKDAY;
ALTER TABLE ART_JOB_SCHEDULES DROP COLUMN WEEKDAY;

