-- Upgrade script from ART 3.2 to ART 3.3

-- CHANGES:
-- update database version
-- add job error notification to column
-- add reference records for new report types
-- add fields for password encryptor type
-- rename art queries database_id field
-- set foreign keys to null where value is 0
-- allow report rule field name column to be null

-- ------------------------------------------------


-- update database version
UPDATE ART_DATABASE_VERSION SET DATABASE_VERSION='3.3';

-- add job error notification to column
ALTER TABLE ART_JOBS ADD ERROR_EMAIL_TO VARCHAR(500);

-- add reference records for new report types
INSERT INTO ART_REPORT_TYPES VALUES (158,'ReportEngine');
INSERT INTO ART_REPORT_TYPES VALUES (159,'ReportEngine: File');

-- add fields for password encryptor type
ALTER TABLE ART_ENCRYPTORS ADD OPEN_PASSWORD VARCHAR(200);
ALTER TABLE ART_ENCRYPTORS ADD MODIFY_PASSWORD VARCHAR(200);

-- rename art queries database_id field
ALTER TABLE ART_QUERIES ADD DATASOURCE_ID INTEGER;
UPDATE ART_QUERIES SET DATASOURCE_ID=DATABASE_ID;
ALTER TABLE ART_QUERIES DROP COLUMN DATABASE_ID;
UPDATE ART_QUERIES SET DATASOURCE_ID=NULL WHERE DATASOURCE_ID=0;

-- set foreign keys to null where value is 0
UPDATE ART_USERS SET DEFAULT_QUERY_GROUP=NULL WHERE DEFAULT_QUERY_GROUP=0;
UPDATE ART_USER_GROUPS SET DEFAULT_QUERY_GROUP=NULL WHERE DEFAULT_QUERY_GROUP=0;
UPDATE ART_QUERIES SET ENCRYPTOR_ID=NULL WHERE ENCRYPTOR_ID=0;
UPDATE ART_PARAMETERS SET DEFAULT_VALUE_REPORT_ID=NULL WHERE DEFAULT_VALUE_REPORT_ID=0;
UPDATE ART_PARAMETERS SET LOV_REPORT_ID=NULL WHERE LOV_REPORT_ID=0;
UPDATE ART_JOBS SET RECIPIENTS_QUERY_ID=NULL WHERE RECIPIENTS_QUERY_ID=0;
UPDATE ART_JOBS SET SCHEDULE_ID=NULL WHERE SCHEDULE_ID=0;
UPDATE ART_JOBS SET SMTP_SERVER_ID=NULL WHERE SMTP_SERVER_ID=0;

-- allow report rule field name column to be null
ALTER TABLE ART_QUERY_RULES ADD TEMP_FIELD_NAME VARCHAR(100);
UPDATE ART_QUERY_RULES SET TEMP_FIELD_NAME=FIELD_NAME;
ALTER TABLE ART_QUERY_RULES DROP COLUMN FIELD_NAME;
ALTER TABLE ART_QUERY_RULES ADD FIELD_NAME VARCHAR(100);
UPDATE ART_QUERY_RULES SET FIELD_NAME=TEMP_FIELD_NAME;
ALTER TABLE ART_QUERY_RULES DROP COLUMN TEMP_FIELD_NAME;
