/*
 * ART. A Reporting Tool.
 * Copyright (C) 2017 Enrico Liboni <eliboni@users.sf.net>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package art.runreport;

import java.io.Serializable;

/**
 * Represents a report output generator result
 * 
 * @author Timothy Anyona
 */
public class ReportOutputGeneratorResult implements Serializable {
	
	private static final long serialVersionUID = 1L;
	private String message;
	private boolean success;
	private Integer rowCount;
	private boolean tooManyRows;

	/**
	 * @return the tooManyRows
	 */
	public boolean isTooManyRows() {
		return tooManyRows;
	}

	/**
	 * @param tooManyRows the tooManyRows to set
	 */
	public void setTooManyRows(boolean tooManyRows) {
		this.tooManyRows = tooManyRows;
	}

	/**
	 * @return the message
	 */
	public String getMessage() {
		return message;
	}

	/**
	 * @param message the message to set
	 */
	public void setMessage(String message) {
		this.message = message;
	}

	/**
	 * @return the success
	 */
	public boolean isSuccess() {
		return success;
	}

	/**
	 * @param success the success to set
	 */
	public void setSuccess(boolean success) {
		this.success = success;
	}

	/**
	 * @return the rowCount
	 */
	public Integer getRowCount() {
		return rowCount;
	}

	/**
	 * @param rowCount the rowCount to set
	 */
	public void setRowCount(Integer rowCount) {
		this.rowCount = rowCount;
	}
	

}
